import { ViewBase } from '../../libappbase/viewbase';
import { UIWaitSOP } from '../../libappsop/objectsop';
import { AppMP } from '../appmp';
import { FormOperationFeedback } from '../forms/form.operationfeedback';
import { FormTripFeedback } from '../forms/form.tripfeedback';

/**
 * Plan > Feedback view which shows trip and operation feedback.
 */
export class ViewFeedback extends ViewBase implements UIWaitSOP {
  public readonly name = 'Feedback';
  public readonly viewPath = 'Plan > Feedback';

  public formOperationFeedback = new FormOperationFeedback();
  public formTripFeedback = new FormTripFeedback();

  public async switchTo(): Promise<void> {
    const appMP = AppMP.getInstance();

    await appMP.abpPlan.click();
    await appMP.abpPlan.btnFeedback.click();

    await this.waitUILoaded();
  }

  public async waitUILoaded(): Promise<void> {
    await this.formOperationFeedback.waitUntilPresent();
    await this.formTripFeedback.waitUntilPresent();
  }
}
